import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrClassrelationtemplate {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  Name?: string;
  SchoolId!: bigint;
  GradeId!: bigint;
  ClassId!: bigint;
  TeacherId?: bigint;
  SubjectId?: bigint;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrClassrelationtemplateSchema = defineEntity({
  class: IcrClassrelationtemplate,
  comment: '班级关联模板',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    Name: p.string().name('Name').nullable().comment('模板名称'),
    SchoolId: p.bigint().name('SchoolId').comment('学校Id'),
    GradeId: p.bigint().name('GradeId').comment('年级Id'),
    ClassId: p.bigint().name('ClassId').comment('班级id'),
    TeacherId: p.bigint().name('TeacherId').nullable().comment('教师Id'),
    SubjectId: p.bigint().name('SubjectId').nullable().comment('学科Id'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
